-- Birth of the Solar System
-- Hit any key to quit

without type_check
without warning

include graphics.e

constant GRAPHICS_MODE = 18  -- try other modes!

function abs(atom x)
-- absolute value   
    if x < 0 then
	return -x
    else
	return x
    end if
end function

sequence vc
integer x_pixels, y_pixels, colors, x, y, c, xd, yd, band_width, cmax
object temp

if graphics_mode(GRAPHICS_MODE) then
    puts(1, "Try a lower graphics mode\n")
    abort(1)
end if

vc = video_config()
x_pixels = vc[VC_XPIXELS]
y_pixels = vc[VC_YPIXELS]
colors = vc[VC_NCOLORS]
band_width = 50

while 1 do
    x = rand(x_pixels)-1
    y = rand(y_pixels)-1
    xd = abs(x - (x_pixels/2))
    yd = abs(y - (y_pixels/2))
    cmax = 1 + floor(sqrt((power(xd/x_pixels, 2) + power(yd/y_pixels, 2))/.5) 
	   * (colors-2))
    if cmax > band_width then
	c = rand(band_width) + cmax - band_width
    else
	c = rand(cmax)
    end if
    pixel(c, {x, y})
    if rand(200) = 99 then
	if get_key() != -1 then
	    exit
	end if
	temp = palette(rand(colors-1), rand(repeat(64, 3)) - 1)
	if band_width > 1 and rand(10) = 5 then
	    band_width = band_width - 1
	end if
    end if
end while
if graphics_mode(-1) then
end if

